//=======================================================
// Mixins
//=======================================================

// 2.0.x: Remove? I think we do not need this

// Clearfix
@mixin clearfix {
  &::after {
    content: '';
    display: table;
    clear: both;
  }
}

// Makes an element visually hidden, but accessible.
// @see http://snook.ca/archives/html_and_css/hiding-content-for-accessibility
@mixin element-invisible {
  position: absolute !important;
  height: 1px;
  width: 1px;
  overflow: hidden;
  clip: rect(1px, 1px, 1px, 1px);
}

// Turns off the element-invisible effect.
@mixin element-invisible-off {
  position: static !important;
  clip: auto;
  height: auto;
  width: auto;
  overflow: auto;
}

// Makes an element visually hidden by default, but visible when focused.
@mixin element-focusable {
  @include element-invisible;

  &:active,
  &:focus {
    @include element-invisible-off;
  }
}

// Helper function for working with Sass maps.
// Example: @include print($configuration);
@mixin print($declarations) {
  @each $property, $value in $declarations {
    #{$property}: $value;
  }
}

/* wrap long words to fit their container and add hyphens where supported */ 
@mixin word-wrap() {
  overflow-wrap: break-word;
  word-wrap: break-word;
  -ms-word-break: break-all;
  word-break: break-all;
  word-break: break-word;
  -ms-hyphens: auto;
  -moz-hyphens: auto;
  -webkit-hyphens: auto;
  hyphens: auto;
  -webkit-hyphenate-limit-lines: 2;
  hyphenate-limit-lines: 2;
  -webkit-hyphenate-limit-chars: 6 3 3;
  hyphenate-limit-chars: 6 3 3;
}

/* cut overly long words to fit their container and add an ellipsis */
@mixin ellipsis {
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}

/* common declarations for the popup and preview close buttons */
@mixin close-button {
  position: absolute;
  top: 0;
  right: 0;
  width: 2rem;
  height: 2rem;
  font: bold 1.25rem/1 "Titillium Web", sans-serif; /* to overwrite some hardcoded leaflet + bulma code */
  padding: 0.4rem 0.75rem;
  cursor: pointer;
  pointer-events: all;
  color: var(--enzian-color-white);
  z-index: 1002;
}
